diff --git a/src/nsterm.m b/src/nsterm.m
index 2defb9e2ee..2ca3f6f3ff 100644
--- a/src/nsterm.m
+++ b/src/nsterm.m
@@ -5602,7 +5602,7 @@ Needs to be here because ns_initialize_display_info () uses AppKit classes.
   ns_drag_types = [[NSArray arrayWithObjects:
                             NSPasteboardTypeString,
                             NSPasteboardTypeTabularText,
-                            NSFilenamesPboardType,
+                            NSPasteboardTypeFileURL,
                             NSPasteboardTypeURL, nil] retain];
 
   /* If fullscreen is in init/default-frame-alist, focus isn't set
@@ -8533,23 +8533,17 @@ -(BOOL)performDragOperation: (id <NSDraggingInfo>) sender
     {
       return NO;
     }
-  /* FIXME: NSFilenamesPboardType is deprecated in 10.14, but the
-     NSURL method can only handle one file at a time.  Stick with the
-     existing code at the moment.  */
-  else if ([type isEqualToString: NSFilenamesPboardType])
+  else if ([type isEqualToString: NSPasteboardTypeFileURL])
     {
-      NSArray *files;
-      NSEnumerator *fenum;
-      NSString *file;
-
-      if (!(files = [pb propertyListForType: type]))
-        return NO;
-
       type_sym = Qfile;
 
-      fenum = [files objectEnumerator];
-      while ( (file = [fenum nextObject]) )
-        strings = Fcons ([file lispString], strings);
+      NSArray *a = [pb readObjectsForClasses: @[[NSURL self]]
+                                     options: nil];
+      NSEnumerator *ae = [a objectEnumerator];
+      NSURL *u;
+      while ((u = [ae nextObject])) {
+        strings = Fcons ([[u path] lispString], strings);
+      }
     }
   else if ([type isEqualToString: NSPasteboardTypeURL])
     {
